<?php

function parseHeaderPart($output)
{

    global $s_header_part_separator;
    global $s_user_program_exit_code;
    global $s_runnerVersion;
    global $s_timeForCompiling;
    global $s_timeForUserProgram;
    global $s_output_without_header_part;


    //if we have no header tuples we might have only so ---\n
    //this is because we cannot use $headerPos -1
    $headerPos = strpos($output, $s_header_part_separator);
    $headerPartText = substr($output, 0, $headerPos);
    $stripedOutput = substr($output, $headerPos + strlen($s_header_part_separator));

    $exit = NULL;
    $runnerVersion = NULL;
    $timeForCompiling = NULL;
    $timeForUserProgram = NULL;


    $headerPartLines = explode("\n", $headerPartText);

    //empty lines will be ignored because no case matches

    foreach ($headerPartLines as $line) {

        if (strpos($line, $s_user_program_exit_code) === 0) {

            $val = getTuple($line);
            if ($val === null) continue; //nothing would change...

            $exit = intval($val, 10);

        } else if (strpos($line, $s_runnerVersion) === 0) {

            $val = getTuple($line);
            if ($val === null) continue;

            $runnerVersion = $val;

        } else if (strpos($line, $s_timeForCompiling) === 0) {

            $val = getTuple($line);
            if ($val === null) continue;

            $timeForCompiling = intval($val, 10);

        } else if (strpos($line, $s_timeForUserProgram) === 0) {

            $val = getTuple($line);
            if ($val === null) continue;

            $timeForUserProgram = intval($val, 10);

        }
    }


    return array(
        $s_user_program_exit_code => $exit,
        $s_runnerVersion => $runnerVersion,
        $s_timeForCompiling => $timeForCompiling,
        $s_timeForUserProgram => $timeForUserProgram,
        $s_output_without_header_part => $stripedOutput,
    );
}

function getTuple($tupleString)
{
    $tuple = explode(':', $tupleString);

    if (count($tuple) !== 2) return NULL;

    return $tuple[1] === "null"
        ? NULL
        : $tuple[1];
}